## zarchive 0.1.2

=== CMakeLists.txt ===
﻿cmake_minimum_required (VERSION 3.15)

if (WIN32)
    set(VCPKG_TARGET_TRIPLET "x64-windows-static" CACHE STRING "VCPKG Target Triplet to use")
endif()

project("ZArchive"
    VERSION "0.1.2"
    DESCRIPTION "Library for creating and reading zstd-compressed file archives"
    HOMEPAGE_URL "https://github.com/Exzap/ZArchive"
)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)

set(SOURCE_FILES_LIB
    src/zarchivewriter.cpp
    src/zarchivereader.cpp
    src/sha_256.c
)

# build static library
add_library (zarchive ${SOURCE_FILES_LIB})
add_library (ZArchive::zarchive ALIAS zarchive)
target_compile_features(zarchive PUBLIC cxx_std_20)
set_target_properties(zarchive PROPERTIES
    MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    VERSION "${PROJECT_VERSION}"
    SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
)

target_include_directories(zarchive
    PUBLIC
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

find_package(zstd MODULE REQUIRED) # MODULE because zstd::zstd is not defined upstream
target_link_libraries(zarchive PRIVATE zstd::zstd)

# standalone executable
add_executable (zarchiveTool src/main.cpp)
set_property(TARGET zarchiveTool PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
set_target_properties(zarchiveTool PROPERTIES OUTPUT_NAME "zarchive")
target_link_libraries(zarchiveTool PRIVATE zarchive)

# install
install(DIRECTORY include/zarchive/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/zarchive" FILES_MATCHING PATTERN "zarchive*.h")
install(TARGETS zarchive)
install(TARGETS zarchiveTool)

# pkg-config
include(JoinPaths) # can be replaced by cmake_path(APPEND) in CMake 3.20
join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

configure_file("zarchive.pc.in" "zarchive.pc" @ONLY)
install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/zarchive.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== debian/changelog ===
zarchive (0.1.2-3) unstable; urgency=low

  * First dgit upload
  * d/control: apply X-Style black
  * d/control: declare dpkg-build-api = 1
  * d/control: use my @debian.org email address
  * d/README.source: document packaging workflow

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 16 Apr 2025 16:07:57 +0200

zarchive (0.1.2-2) unstable; urgency=medium

  * d/patches: always link to libzstd dynamically

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 13 Jan 2023 22:13:39 +0100

zarchive (0.1.2-1) unstable; urgency=low

  * Initial release. Closes: #1018223

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 01 Sep 2022 17:19:02 +0200

=== debian/control ===
Source: zarchive
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
Build-Depends-Arch:
 cmake,
 libzstd-dev,
 pkg-config,
Standards-Version: 4.7.2
Homepage: https://github.com/Exzap/ZArchive
Vcs-Git: https://salsa.debian.org/debian/zarchive.git
Vcs-Browser: https://salsa.debian.org/debian/zarchive
X-Style: black

Package: libzarchive0.1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for creating and reading zstd-compressed files
 ZArchive is yet another file archive format. Think of zip, tar, 7z,
 etc. but with the requirement of allowing random-access reads and
 supporting Zstandard compression.
 .
 This package contains the shared library.

Package: libzarchive-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libzarchive0.1 (= ${binary:Version}),
 ${misc:Depends},
Description: library for creating and reading zstd-compressed files - development files
 ZArchive is yet another file archive format. Think of zip, tar, 7z,
 etc. but with the requirement of allowing random-access reads and
 supporting Zstandard compression.
 .
 This package contains the development files.

Package: zarchive-tools
Section: utils
Architecture: any
Multi-Arch: foreign
Depends:
 libzarchive0.1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: tool for creating and reading zstd-compressed files
 ZArchive is yet another file archive format. Think of zip, tar, 7z,
 etc. but with the requirement of allowing random-access reads and
 supporting Zstandard compression.
 .
 This package contains the zarchive tool, that allows you to create and
 read file archives in the ZArchive format (.zar).

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=true \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=true \
		-DCMAKE_C_VISIBILITY_PRESET=hidden
